Load a WFS feature table using an XML query.

Use case
QueryParameters objects can’t represent all possible queries that can be made against a WFS feature service. For example, query parameters don’t support wildcard searches. You can provide queries as raw XML strings, allowing you to access query functionality not available with QueryParameters.
How to use the sample
Run the sample and view the data loaded from the the WFS feature table.
How it works
- Create a
WfsFeatureTableand aFeatureLayerto visualize the table. - Set the feature request mode to
ManualCache. - Call
populateFromServiceAsyncto populate the table with only those features returned by the XML query.
Relevant API
- FeatureLayer
- WfsFeatureTable
- WfsFeatureTable::axisOrder
- WfsFeatureTable::populateFromServiceAsync
About the data
This service shows trees in downtown Seattle and the surrounding area. An XML-encoded GetFeature request is used to limit results to only trees of the genus Tilia.
For additional information, see the underlying service on ArcGIS Online.
Tags
feature, OGC, query, service, web, WFS, XML
Sample Code
// [WriteFile Name=LoadWfsXmlQuery, Category=Layers]// [Legal]// Copyright 2019 Esri.//// Licensed under the Apache License, Version 2.0 (the "License");// you may not use this file except in compliance with the License.// You may obtain a copy of the License at// http://www.apache.org/licenses/LICENSE-2.0//// Unless required by applicable law or agreed to in writing, software// distributed under the License is distributed on an "AS IS" BASIS,// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.// See the License for the specific language governing permissions and// limitations under the License.// [Legal]
#ifdef PCH_BUILD#include "pch.hpp"#endif // PCH_BUILD
// sample headers#include "LoadWfsXmlQuery.h"
// ArcGIS Maps SDK headers#include "Envelope.h"#include "Error.h"#include "FeatureLayer.h"#include "GeodatabaseTypes.h"#include "LayerListModel.h"#include "Map.h"#include "MapQuickView.h"#include "MapTypes.h"#include "WfsFeatureTable.h"
// Qt headers#include <QFuture>
using namespace Esri::ArcGISRuntime;
namespace{ const QString xmlQueryString = R"( <wfs:GetFeature service="WFS" version="2.0.0" xmlns:Seattle_Downtown_Features="https://dservices2.arcgis.com/ZQgQTuoyBrtmoGdP/arcgis/services/Seattle_Downtown_Features/WFSServer" xmlns:wfs="http://www.opengis.net/wfs/2.0" xmlns:fes="http://www.opengis.net/fes/2.0" xmlns:gml="http://www.opengis.net/gml/3.2"> <wfs:Query typeNames="Seattle_Downtown_Features:Trees"> <fes:Filter> <fes:PropertyIsLike wildCard="*" escapeChar="\"> <fes:ValueReference>Trees:SCIENTIFIC</fes:ValueReference> <fes:Literal>Tilia *</fes:Literal> </fes:PropertyIsLike> </fes:Filter> </wfs:Query> </wfs:GetFeature>)";}
LoadWfsXmlQuery::LoadWfsXmlQuery(QObject* parent /* = nullptr */): QObject(parent), m_map(new Map(BasemapStyle::ArcGISNavigation, this)){ // create WFS Feature Table const QUrl featureTableUrl("https://dservices2.arcgis.com/ZQgQTuoyBrtmoGdP/arcgis/services/Seattle_Downtown_Features/WFSServer?service=wfs&request=getcapabilities"); WfsFeatureTable* wfsFeatureTable = new WfsFeatureTable(featureTableUrl, "Seattle_Downtown_Features:Trees", this); wfsFeatureTable->setFeatureRequestMode(FeatureRequestMode::ManualCache);
// connect to feature table doneLoading signal connect(wfsFeatureTable, &WfsFeatureTable::doneLoading, this, [wfsFeatureTable, this](const Error& e) { if (!e.isEmpty()) return;
// populate the table with XML Query auto future = wfsFeatureTable->populateFromServiceAsync(xmlQueryString, true); Q_UNUSED(future)
// set the viewpoint to the center of the extent m_mapView->setViewpointGeometryAsync(wfsFeatureTable->extent(), 50); });
// create Feature Layer FeatureLayer* featureLayer = new FeatureLayer(wfsFeatureTable, this);
// add layer to the map m_map->operationalLayers()->append(featureLayer);}
LoadWfsXmlQuery::~LoadWfsXmlQuery() = default;
void LoadWfsXmlQuery::init(){ // Register the map view for QML qmlRegisterType<MapQuickView>("Esri.Samples", 1, 0, "MapView"); qmlRegisterType<LoadWfsXmlQuery>("Esri.Samples", 1, 0, "LoadWfsXmlQuerySample");}
MapQuickView* LoadWfsXmlQuery::mapView() const{ return m_mapView;}
// Set the view (created in QML)void LoadWfsXmlQuery::setMapView(MapQuickView* mapView){ if (!mapView || mapView == m_mapView) return;
m_mapView = mapView; m_mapView->setMap(m_map);
emit mapViewChanged();}// [WriteFile Name=LoadWfsXmlQuery, Category=Layers]// [Legal]// Copyright 2019 Esri.//// Licensed under the Apache License, Version 2.0 (the "License");// you may not use this file except in compliance with the License.// You may obtain a copy of the License at// http://www.apache.org/licenses/LICENSE-2.0//// Unless required by applicable law or agreed to in writing, software// distributed under the License is distributed on an "AS IS" BASIS,// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.// See the License for the specific language governing permissions and// limitations under the License.// [Legal]
#ifndef LOADWFSXMLQUERY_H#define LOADWFSXMLQUERY_H
// Qt headers#include <QObject>
namespace Esri::ArcGISRuntime{class Map;class MapQuickView;}
Q_MOC_INCLUDE("MapQuickView.h")
class LoadWfsXmlQuery : public QObject{ Q_OBJECT
Q_PROPERTY(Esri::ArcGISRuntime::MapQuickView* mapView READ mapView WRITE setMapView NOTIFY mapViewChanged)
public: explicit LoadWfsXmlQuery(QObject* parent = nullptr); ~LoadWfsXmlQuery();
static void init();
signals: void mapViewChanged();
private: Esri::ArcGISRuntime::MapQuickView* mapView() const; void setMapView(Esri::ArcGISRuntime::MapQuickView* mapView);
Esri::ArcGISRuntime::Map* m_map = nullptr; Esri::ArcGISRuntime::MapQuickView* m_mapView = nullptr;};
#endif // LOADWFSXMLQUERY_H// [WriteFile Name=LoadWfsXmlQuery, Category=Layers]// [Legal]// Copyright 2019 Esri.//// Licensed under the Apache License, Version 2.0 (the "License");// you may not use this file except in compliance with the License.// You may obtain a copy of the License at// http://www.apache.org/licenses/LICENSE-2.0//// Unless required by applicable law or agreed to in writing, software// distributed under the License is distributed on an "AS IS" BASIS,// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.// See the License for the specific language governing permissions and// limitations under the License.// [Legal]
import QtQuickimport QtQuick.Controlsimport Esri.Samples
Item {
// add a mapView component MapView { id: view anchors.fill: parent
Component.onCompleted: { // Set the focus on MapView to initially enable keyboard navigation forceActiveFocus(); } }
// Declare the C++ instance which creates the map etc. and supply the view LoadWfsXmlQuerySample { id: model mapView: view }}// [Legal]// Copyright 2019 Esri.//// Licensed under the Apache License, Version 2.0 (the "License");// you may not use this file except in compliance with the License.// You may obtain a copy of the License at// http://www.apache.org/licenses/LICENSE-2.0//// Unless required by applicable law or agreed to in writing, software// distributed under the License is distributed on an "AS IS" BASIS,// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.// See the License for the specific language governing permissions and// limitations under the License.// [Legal]
// sample headers#include "LoadWfsXmlQuery.h"
// ArcGIS Maps SDK headers#include "ArcGISRuntimeEnvironment.h"
// Qt headers#include <QDir>#include <QGuiApplication>#include <QQmlApplicationEngine>
// Platform specific headers#ifdef Q_OS_WIN#include <Windows.h>#endif
#define STRINGIZE(x) #x#define QUOTE(x) STRINGIZE(x)
int main(int argc, char *argv[]){ Esri::ArcGISRuntime::ArcGISRuntimeEnvironment::setUseLegacyAuthentication(false); QGuiApplication app(argc, argv); app.setApplicationName(QString("LoadWfsXmlQuery"));
// Use of ArcGIS location services, such as basemap styles, geocoding, and routing services, // requires an access token. For more information see // https://links.esri.com/arcgis-runtime-security-auth.
// The following methods grant an access token:
// 1. User authentication: Grants a temporary access token associated with a user's ArcGIS account. // To generate a token, a user logs in to the app with an ArcGIS account that is part of an // organization in ArcGIS Online or ArcGIS Enterprise.
// 2. API key authentication: Get a long-lived access token that gives your application access to // ArcGIS location services. Go to the tutorial at https://links.esri.com/create-an-api-key. // Copy the API Key access token.
const QString accessToken = QString("");
if (accessToken.isEmpty()) { qWarning() << "Use of ArcGIS location services, such as the basemap styles service, requires" << "you to authenticate with an ArcGIS account or set the API Key property."; } else { Esri::ArcGISRuntime::ArcGISRuntimeEnvironment::setApiKey(accessToken); }
// Initialize the sample LoadWfsXmlQuery::init();
QString arcGISRuntimeImportPath = QUOTE(ARCGIS_RUNTIME_IMPORT_PATH);
#if defined(LINUX_PLATFORM_REPLACEMENT) // on some linux platforms the string 'linux' is replaced with 1 // fix the replacement paths which were created QString replaceString = QUOTE(LINUX_PLATFORM_REPLACEMENT); arcGISRuntimeImportPath = arcGISRuntimeImportPath.replace(replaceString, "linux", Qt::CaseSensitive);#endif
// Initialize application view QQmlApplicationEngine engine; // Add the import Path engine.addImportPath(QDir(QCoreApplication::applicationDirPath()).filePath("qml")); // Add the Runtime and Extras path engine.addImportPath(arcGISRuntimeImportPath);
// Set the source engine.load(QUrl("qrc:/Samples/Layers/LoadWfsXmlQuery/main.qml"));
return app.exec();}// Copyright 2019 ESRI//// All rights reserved under the copyright laws of the United States// and applicable international laws, treaties, and conventions.//// You may freely redistribute and use this sample code, with or// without modification, provided you include the original copyright// notice and use restrictions.//// See the Sample code usage restrictions document for further information.//
import QtQuick.Controlsimport Esri.Samples
ApplicationWindow { visible: true width: 800 height: 600
LoadWfsXmlQuery { anchors.fill: parent }}